;*************************************************************** 
;* Project Name: 
;* Project Description :
; 
;* Author: 
;* Lab_group: <merocsoprt jele>
;* Last edited: <Enter the date here>  
;
;***************************************************************
;* "AVR ExperimentBoard" port assignment information:
;***************************************************************
;*
;* LED0(P):PortC.0          LED4(P):PortC.4
;* LED1(P):PortC.1          LED5(P):PortC.5
;* LED2(S):PortC.2          LED6(S):PortC.6
;* LED3(Z):PortC.3          LED7(Z):PortC.7        INT:PortE.4
;*
;* SW0:PortG.0     SW1:PortG.1     SW2:PortG.4     SW3:PortG.3
;* 
;* BT0:PortE.5     BT1:PortE.6     BT2:PortE.7     BT3:PortB.7
;*
;***************************************************************
;*
;* AIN:PortF.0     NTK:PortF.1    OPTO:PortF.2     POT:PortF.3
;*
;***************************************************************
;*
;* LCD1(VSS) = GND         LCD9(DB2): -
;* LCD2(VDD) = VCC         LCD10(DB3): -
;* LCD3(VO ) = GND         LCD11(DB4): PortA.4
;* LCD4(RS ) = PortA.0     LCD12(DB5): PortA.5
;* LCD5(R/W) = GND         LCD13(DB6): PortA.6
;* LCD6(E  ) = PortA.1     LCD14(007): PortA.7
;* LCD7(DB0) = -           LCD15(BLA): VCC
;* LCD8(DB1) = -           LCD16(BLK): PortB.5 (1=Backlight ON)
;*
;***************************************************************

.include "m128def.inc" ; Definition file for ATmega128 
;* Program Constants 
.equ const =$00 ; Generic Constant Structure example 
.equ value = 200; A fényérzékelő küszöbszintje (max 255)
;* Program Variables Definitions 
.def temp =r16 ; Temporary Register example 
.def temp2 = r17
.def burglar = r18 ;hogy érzékeltünk-e betörőt
.def pressed = r20; megnyomtuk a gombot(1), vagy sem(0)
.def stat = r19; zöld(0) vagy piros(1) állapotban vagyunk-e
;*************************************************************** 
;* Reset & Interrupt Vectors  
.cseg 
.org $0000 ; Define start of Code segment 
	jmp RESET ; Reset Handler, jmp is 2 word instruction 

	reti ; INT0 Handler on $0002, dummy 
	nop 
	reti ; INT1 Handler, if INTn used, 'reti' and 'nop' 
	     ; will be replaced by 'jmp INTn_Handler_Address'
	nop 
	reti ; INT2 Handler 
	nop 
	reti ; INT3 Handler 
	nop 
	reti ; INT4 Handler 
	nop 
	jmp buttonPressed ; INT5 Handler 
	;nop 
	reti ; INT6 Handler 
	nop 
	reti ; INT7 Handler 
	nop 
	reti ; Timer2 Compare Match Handler 
	nop 
	reti ; Timer2 Overflow Handler 
	nop 
	reti ; Timer1 Capture Event Handler 
	nop 
	reti ; Timer1 Compare Match A Handler 
	nop 
	reti ; Timer1 Compare Match B Handler 
	nop 
	jmp blinkLED ; Timer1 Overflow Handler 
	;nop 
	reti ; Timer0 Compare Match Handler 
	nop 
	reti ; Timer0 Overflow Handler 
	nop 
	reti ; SPI Transfer Complete Handler 
	nop 
	reti ; USART0 RX Complete Handler 
	nop 
	reti ; USART0 Data Register Empty Hanlder 
	nop 
	reti ; USART0 TX Complete Handler 
	nop 
	jmp detectBurglar ; ADC Conversion Complete Handler 
	;nop 
	reti ; EEPROM Ready Hanlder 
	nop 
	reti ; Analog Comparator Handler 
	nop 
	reti ; Timer1 Compare Match C Handler 
	nop
	reti ; Timer3 Capture Event Handler 
	nop 
	reti ; Timer3 Compare Match A Handler 
	nop 
	reti ; Timer3 Compare Match B Handler 
	nop 
	reti ; Timer3 Compare Match C Handler 
	nop 
	reti ; Timer3 Overflow Handler 
	nop 
	reti ; USART1 RX Complete Handler 
	nop 
	reti ; USART1 Data Register Empty Hanlder 
	nop 
	reti ; USART1 TX Complete Handler 
	nop 
	reti ; Two-wire Serial Interface Handler 
	nop 
	reti ; Store Program Memory Ready Handler 
	nop 
	
;*************************************************************** 
;* MAIN program, Initialisation part
.org $0046;
M_INIT:
RESET: 
;* Stack Pointer init, 
;  Set stack pointer to top of RAM 
	ldi temp, LOW(RAMEND) ; RAMEND = max address in RAM"
	out SPL, temp 	      ; RAMEND value in "m128def.inc" 
	ldi temp, HIGH(RAMEND) 
	out SPH, temp 

	ser temp;
	out DDRC, temp ;A LED-ek kimenetre állítása

	clr temp
	out DDRE, temp ;A gombok bemenetre állítása
	
	ldi temp, 0b00001000; a PORTE5-ön lévő gomb interrupt beállítása: lefutó éldlre reagál
	out EICRB, temp

	;ldi temp, 0b00100000; PORTE5-ön lévő gomb interrupt engedélyezése
	;out EIMSK, temp

	ldi temp, 0b11100010; A/D konverter beállítása: 2.56V reffeszültség, ADCH-ban vannak a magasabb bitek (8magas bit), PORTF2-ről olvasunk
	out ADMUX, temp

	ldi temp, 0b11101111; A/D konvertel engedélyezés, szabad futású mód, interrupt egedélyezése, 128-as leosztás
	out ADCSRA, temp

	ldi temp, 0b00000011 ; timer beállítása, fastPWM 10-bites
	out TCCR1A, temp
	
	ldi temp, 0b00001101; fastPWM 10-bites, 1024-es leosztás, 0-tól 1024-ig számol, majd megint 0-1024-ig
	out TCCR1B, temp

	;ldi temp, 0b000100; timer overflow interrupt engedélyezése
	;out TIMSK, temp

	ldi temp, 0b10001000; zöld LED-ek világítanak
	out PORTC, temp

	ldi stat, 0; zöld állapot a kezdő
	sei

;< Insert your other initialisation code here> 

;*************************************************************** 
;* MAIN program, Endless loop part
 
M_LOOP: 

	cpi stat, 0
	breq stat0
	cpi stat, 1
	breq stat1

	jmp RESET; ha a stat nem 0, vagy 1, akkor hiba van, reset
	jmp end

stat0:; a zöld állapotban vagyunk
	cpi burglar, 0 ; és nincs betörő
	breq end ;continue

	;egyébként átlépünk piros állapotba
	cli
	ldi burglar, 0; kinullázzuk a betörő jelzőt
	cbi ADCSRA, ADIE; letiltjuk az A/D konvertert
	ldi temp, 0b00110011; piros LED-ek világítanak
	out PORTC, temp
	clr temp ;lenullázzuk a timer-t
	out TCNT1H, temp
	out TCNT1L, temp
	ldi temp, 0b000100; timer overflow interrupt engedélyezése
	out TIMSK, temp
	ldi temp, 0b00100000; PORTE5-ön lévő gomb interrupt engedélyezése
	out EIMSK, temp
	ldi stat, 1 ;átváltunk piros állapotba
	sei
	jmp end

stat1:; a piros állapotban vagyunk
	cpi pressed, 0; ha nem nyomták meg a gombot
	breq end ; continue

	;egyébként átlépünk zöld állapotba
	cli
	clr pressed; kinullázzuk a gomb-megnyomás jelzőt
	clr temp
	out EIMSK, temp ;PORTE5-ön lévő gomb interrupt letiltása
	out TIMSK, temp ;Timer interrupt letiltása
	ldi temp, 0b10001000; zöld LED-ek világítanak
	out PORTC, temp
	sbi ADCSRA, ADIE; A/D converter beindítása
	ldi stat, 0 ;átváltunk zöld állapotba
	sei
	jmp end

end:
	jmp M_LOOP ; Endless Loop  


;*************************************************************** 
;* Subroutins, Interrupt routins

;A gombnyomást lekezelő interrupt
buttonPressed:
	ldi pressed, 1
    ldi temp, 0b00000000; PORTE5-ön lévő gomb interrupt engedélyezése
	out EIMSK, temp
reti
;------------------------------------------------------------------------------

;az A/D konverter interruptot lekezelő függvény, 1-et rak a burglar-ba, ha betörőt érzékelt, 0-t, ha nem
detectBurglar:
	
	push temp2
	push temp
	in temp, SREG
	push temp

	ldi burglar, 0; alapértelmezett visszatérési érték: nincs betörő
	in temp, ADCH ;az magas bitek kimentése

	cpi temp, value; összehasonlítás a küszöbszinttel
	;A fényérzékelő annál nagyobb értéket generál, minél sötétebb van!
	brcs detectBurglar_end ;ha az érzékelt szint kisebb, mint a küszöbszint, akkor visszatérünk 1-val

detectBurglar_end_1:
	ldi burglar, 1; egyébként 1-el
        cbi ADCSRA, ADIE; letiltjuk az A/D konvertert
	
detectBurglar_end:
	pop temp
	out SREG, temp
	pop temp
	pop temp2

reti
;------------------------------------------------------------------------------

;villogtatja a piros LED-eket
blinkLED:
	push temp
	in temp, SREG
	push temp

	in temp, PINC
	com temp ;negáljuk a LED-ek értékeit
	andi temp, 0b00110011 ;kimaszkoljuk a piros LED-ek értékeit
	out PORTC, temp ;kiírjuk

	pop temp
	out SREG, temp
	pop temp

reti






